linear-1.20.3: Linear Algebra

Copyright | (C) 2012-2015 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Linear.Epsilon

Description

Testing for values "near" zero

Synopsis

- class Num a => Epsilon a where
  - nearZero :: a -> Bool

# Documentation

class Num a => Epsilon a where Source

Provides a fairly subjective test to see if a quantity is near zero.

    >>> nearZero (1e-11 :: Double)
    False

    >>> nearZero (1e-17 :: Double)
    True

    >>> nearZero (1e-5 :: Float)
    False

    >>> nearZero (1e-7 :: Float)
    True

Methods

nearZero :: a -> Bool Source

Determine if a quantity is near zero.

Instances

Epsilon Double Source

    abs a <= 1e-12

Epsilon Float Source

    abs a <= 1e-6

Epsilon CFloat Source

    abs a <= 1e-6

Epsilon CDouble Source

    abs a <= 1e-12

Epsilon a => Epsilon (V0 a) Source |
Epsilon a => Epsilon (V1 a) Source |
Epsilon a => Epsilon (V2 a) Source |
Epsilon a => Epsilon (V3 a) Source |
Epsilon a => Epsilon (V4 a) Source |
Epsilon a => Epsilon (Plucker a) Source |
(RealFloat a, Epsilon a) => Epsilon (Quaternion a) Source |
Epsilon (f a) => Epsilon (Point f a) Source |
(Dim k n, Epsilon a) => Epsilon (V k n a) Source |